diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenActivator.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenActivator.java
index d59d6a034..1aa3ea217 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenActivator.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenActivator.java
@@ -12,6 +12,7 @@ import net.minecraft.core.player.inventory.container.ContainerInventory;
 import net.minecraft.core.player.inventory.menu.MenuActivator;
 import net.minecraft.core.player.inventory.slot.Slot;
 import net.minecraft.core.sound.SoundCategory;
+import org.jetbrains.annotations.Nullable;
 
 import java.util.ArrayList;
 import java.util.List;
@@ -88,9 +89,9 @@ public class ScreenActivator extends ScreenContainerAbstract {
         private static final byte NONE = 0, LOCK = 1, UNLOCK = 2;
 
         @Override
-        protected void mousePressed(int x, int y, Slot slot, int button) {
+        protected void mousePressed(int x, int y, @Nullable Slot slot, int button) {
             if (button != 1 || super.isDragging() ||
-                super.getGrabbedItem() != null || slot.getItemStack() != null
+                super.getGrabbedItem() != null || slot == null || slot.getItemStack() != null
             ) {
                 super.mousePressed(x, y, slot, button);
                 return;
diff --git a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
index 064a9a1b3..883fa65f7 100644
--- a/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
+++ b/game/client/src/main/java/net/minecraft/client/gui/container/ScreenContainerAbstract.java
@@ -35,6 +35,7 @@ import net.minecraft.core.player.inventory.slot.SlotCreative;
 import java.util.List;
 
 import org.jetbrains.annotations.NotNull;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.input.Keyboard;
 
 public abstract class ScreenContainerAbstract extends Screen {
@@ -135,7 +136,7 @@ public abstract class ScreenContainerAbstract extends Screen {
         return i >= slot.x - 1 && i < slot.x + 16 + 1 && j >= slot.y - 1 && j < slot.y + 16 + 1;
     }
 
-    public Slot getSlotAtPosition(final int i, final int j) {
+    public @Nullable Slot getSlotAtPosition(final int i, final int j) {
         for (int k = 0; k < this.inventorySlots.slots.size(); k++) {
             final Slot slot = this.inventorySlots.slots.get(k);
             if (getIsMouseOverSlot(slot, i, j)) {
diff --git a/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java b/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
index bc9cc7de2..ccfd71fe4 100644
--- a/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
+++ b/game/client/src/main/java/net/minecraft/client/util/helper/ItemDragHandler.java
@@ -8,6 +8,7 @@ import it.unimi.dsi.fastutil.ints.IntSet;
 import net.minecraft.client.render.renderer.BlendFactor;
 import net.minecraft.client.render.renderer.GLRenderer;
 import net.minecraft.client.render.renderer.State;
+import org.jetbrains.annotations.Nullable;
 import org.lwjgl.input.Keyboard;
 
 import net.minecraft.client.Minecraft;
@@ -170,7 +171,7 @@ public class ItemDragHandler extends Gui {
         this.mc.playerController.handleInventoryMouseClick(this.container.inventorySlots.containerId, action, args, this.mc.thePlayer);
 	}
 	
-	protected void mousePressed(final int x, final int y, final Slot slot, int button) {
+	protected void mousePressed(final int x, final int y, final @Nullable Slot slot, int button) {
 		ItemStack stack = getGrabbedItem();
 		
 		if(button == 0) {
diff --git a/game/core/src/main/java/net/minecraft/core/block/Block.java b/game/core/src/main/java/net/minecraft/core/block/Block.java
index b6c7968bb..cd6a1ac78 100644
--- a/game/core/src/main/java/net/minecraft/core/block/Block.java
+++ b/game/core/src/main/java/net/minecraft/core/block/Block.java
@@ -63,7 +63,6 @@ public final class Block<T extends BlockLogic>
     public int emission;
     public @Nullable Integer lightBlock = null;
     public boolean isEntityTile = false;
-    public boolean disabledNeighborMetaNotify = false;
     public boolean shouldTick = false;
     public @Nullable Supplier<@NotNull TileEntity> entitySupplier;
     public @Nullable MaterialColor overrideColor;
@@ -128,11 +127,6 @@ public final class Block<T extends BlockLogic>
         return this;
     }
 
-    public Block<T> withDisabledNeighborNotifyOnMetadataChange() {
-        this.disabledNeighborMetaNotify = true;
-        return this;
-    }
-
     public Block<T> withLightBlock(final int blockAmount) {
         this.lightBlock = blockAmount;
         return this;
@@ -628,10 +622,6 @@ public final class Block<T extends BlockLogic>
         return Blocks.lightEmission[this.id];
     }
 
-    public boolean neighborNotifyOnDataChangeDisabled() {
-        return Blocks.neighborNotifyOnMetadataChangeDisabled[this.id];
-    }
-
     public static boolean hasLogicClass(@Nullable final Block<?> block, final @NotNull Class<?> logicClass) {
         return block != null && logicClass.isAssignableFrom(block.getLogic().getClass());
     }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAir.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAir.java
index f8fe18d53..f381b4741 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicAir.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicAir.java
@@ -121,4 +121,9 @@ public class BlockLogicAir
     public int getPistonPushReaction(@NotNull World world, @NotNull TilePosc tilePos) {
         return Material.PISTON_DESTROY_ON_PUSH;
     }
+
+    @Override
+    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
+        return false;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
index a911205ad..980dada5f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBasket.java
@@ -69,19 +69,32 @@ public class BlockLogicBasket extends BlockLogic {
     }
 
     public int getFillLevel(final @NotNull WorldSource source, final @NotNull TilePosc tilePos) {
-        if (source.getTileEntity(tilePos) instanceof TileEntityBasket basket) { // Instance check done to avoid a class cast exception that seems to sometimes happen on pushed baskets in mp, sometimes. Probably a synchronization issue in MP needs further evaluation
-            final float fill = MathHelper.clamp(basket.getNumUnitsInside() / (float) basket.getMaxUnits(), 0, 1); // Clamps the visual effect even if the basket gets overstuffed
+        return (source.getTileEntity(tilePos) instanceof TileEntityBasket basket)
+            ? getFillLevel(basket)
+            : 0;
+    }
 
-            return (int) Math.ceil(10 * fill);
-        }
-        return 0;
+    protected static int getFillLevel(@NotNull TileEntityBasket tileEntity) {
+        final float fill = MathHelper.clamp(tileEntity.getNumUnitsInside() / (float) tileEntity.getMaxUnits(), 0, 1); // Clamps the visual effect even if the basket gets overstuffed
+        return (int) Math.ceil(10 * fill);
     }
 
+
     @Deprecated
     public final int getFillLevel(final @NotNull WorldSource source, final int x, final int y, final int z) {
         return this.getFillLevel(source, new TilePos(x, y, z));
     }
 
+    @Override
+    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
+        assert world.getBlockType(thisPos) == this.block;
+        if (world.getBlockType(thatPos) != this.block) return false;
+        if (!(world.getTileEntity(thisPos) instanceof TileEntityBasket thisBasket) ||
+            !(world.getTileEntity(thatPos) instanceof TileEntityBasket thatBasket))
+            return false;
+        return getFillLevel(thisBasket) == getFillLevel(thatBasket);
+    }
+
     @Override
     public boolean isSolidRender() {
         return false;
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
index d29c1ef19..9f0adf63a 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicBed.java
@@ -34,7 +34,7 @@ public class BlockLogicBed
 
     @Override
     protected int getMatcherEquivalenceData(final int data) {
-        return data & ~DIRECTION.mask;
+        return data & ~(DIRECTION.mask | IS_OCCUPIED.mask);
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
index 62d75eadb..0c8daee2f 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicCactus.java
@@ -50,15 +50,11 @@ public class BlockLogicCactus
                 cactusHeight++;
             }
             if (cactusHeight < 3) {
-                final int data = world.getBlockData(tilePos);
-                if (data == 15) {
-                    world.setBlockData(tilePos, 0);
-                    world.setBlockType(tilePos.add(Direction.UP, queryPos), this.block);
-                    world.markBlockNeedsUpdate(tilePos);
-                    world.markBlockNeedsUpdate(queryPos);
-                    world.notifyBlocksInCapsuleOfNeighborChange(Direction.UP, tilePos, this.block);
-                } else {
-                    world.setBlockDataNotify(tilePos, data + 1);
+                int data = world.getBlockData(tilePos);
+                data = (data + 1) & 0xF;
+                world.setBlockData(tilePos, data);
+                if (data == 0) {
+                    world.setBlockTypeNotify(tilePos.add(Direction.UP, queryPos), this.block);
                 }
             }
         }
@@ -148,4 +144,9 @@ public class BlockLogicCactus
         }
         return true;
     }
+
+    @Override
+    protected int getMatcherEquivalenceData(int data) {
+        return 0;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
index f5c36f7a2..8c9255995 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicChest.java
@@ -26,8 +26,11 @@ public class BlockLogicChest
     }
 
     @Override
-    protected int getMatcherEquivalenceData(final int data) {
-        return data & typeBits;
+    protected int getMatcherEquivalenceData(int data) {
+        data &= ~directionBits;
+        assert Type.SINGLE.ordinal() == 0;
+        if ((data & typeBits) != 0) data |= typeBits;
+        return data;
     }
 
     @Override
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java
index 0909fb927..66ac6c306 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicConduit.java
@@ -496,4 +496,11 @@ public class BlockLogicConduit extends BlockLogic {
     public static int signalConverter(int strength, boolean conduitToRedstone) {
         return Math.max(0, Math.min(PROPAGATION_LENGTH, strength));
     }
+
+    @Override
+    protected int getMatcherEquivalenceData(int data) {
+        if ((data & STATE_MASK) == 0) assert getOpenSides(data).length == 0;
+        else data |= STATE_MASK;
+        return data;
+    }
 }
\ No newline at end of file
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
index e07c01202..00f5e7676 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicDoor.java
@@ -62,7 +62,13 @@ public class BlockLogicDoor
 
     @Override
     protected int getMatcherEquivalenceData(final int data) {
-        return data & ~(MASK_ROTATION);
+        final int MASK_NON_COLOR = MASK_OPENED | MASK_HINGE | MASK_ROTATION;
+        int d1 = data & ~MASK_NON_COLOR;
+        int d2 = data &  MASK_NON_COLOR;
+        assert (MASK_HINGE >>> 1) == MASK_OPENED;
+        d2 ^= d2 >>> 1; // flips the opened bit if hinge bit is set
+        d1 |= d2;
+        return d1 & ~(MASK_HINGE | MASK_ROTATION);
     }
 
     @Override
@@ -148,29 +154,36 @@ public class BlockLogicDoor
         if (this.material == Materials.METAL || this.material == Materials.STEEL) {
             return false;
         }
-        TilePos queryPos = new TilePos();
+        final TilePos queryPos = new TilePos();
         final int data = world.getBlockData(tilePos);
+
         if (this.isTop) {
-            final Block<?> b = world.getBlockType(tilePos.down(queryPos));
-            if (b.getLogic() instanceof BlockLogicDoor blockLogicDoor) {
-                blockLogicDoor.onInteracted(world, tilePos.down(queryPos), player, side, xHit, yHit);
-            }
-            return true;
-        }
-        final @Nullable Block<?> b = world.getBlockType(tilePos.up(queryPos));
-        if (b.getLogic() instanceof BlockLogicDoor) {
-            world.setBlockDataNotify(tilePos.up(queryPos), data ^ MASK_OPENED);
+            final var lowerPos = tilePos.down(queryPos);
+
+            final Block<?> b = world.getBlockType(lowerPos);
+            if (!(b.getLogic() instanceof BlockLogicDoor blockLogicDoor)) return false;
+            return blockLogicDoor.onInteracted(world, lowerPos, player, side, xHit, yHit);
         }
+
+        final var upperPos = tilePos.up(queryPos);
+        final boolean hasTop = world.getBlockType(upperPos).getLogic() instanceof BlockLogicDoor;
         final int openedData = data ^ MASK_OPENED;
-        world.setBlockDataNotify(tilePos, openedData);
-        if (!this.isSupported(world, tilePos, openedData)) {
+
+        if (hasTop) world.setBlockData(upperPos, openedData);
+        world.setBlockData(tilePos, openedData);
+
+        if (!this.isSupported(world, tilePos, data)) {
             this.dropWithCause(world, EnumDropCause.WORLD, tilePos, openedData, null, null);
-            world.setBlockTypeNotify(tilePos, Blocks.AIR);
-            if (world.getBlockLogic(tilePos.up(queryPos), BlockLogicDoor.class) != null) {
-                world.setBlockTypeNotify(tilePos.up(queryPos), Blocks.AIR);
-            }
+            
+            world.setBlockType(tilePos, Blocks.AIR);
+            if (hasTop) world.setBlockType(upperPos, Blocks.AIR);
         }
-        world.markBlocksDirty(tilePos.down(queryPos), tilePos);
+
+        // world.markBlocksDirty(tilePos, upperPos);
+        world.markBlockNeedsUpdate(tilePos);
+        world.markBlockNeedsUpdate(upperPos);
+        world.notifyBlocksInCapsuleOfNeighborChange(Direction.UP, tilePos, this.block);
+
         world.playBlockEvent(player, tilePos, LevelListener.EVENT_DOOR_SOUND, 0);
         return true;
     }
@@ -217,13 +230,13 @@ public class BlockLogicDoor
             final @NotNull Block<?> b = world.getBlockType(tilePos.down(queryPos));
             if (!(b.getLogic() instanceof BlockLogicDoor)) {
                 world.setBlockTypeNotify(tilePos, Blocks.AIR);
+                return;
             }
-            if (block.isSignalSource()) {
-                b.onNeighborChanged(world, tilePos.down(queryPos), block);
-            }
+            b.onNeighborChanged(world, tilePos.down(queryPos), block);
         } else {
             boolean hasCommittedSuicide = false;
-            final @NotNull Block<?> otherBlock = world.getBlockType(tilePos.up(queryPos));
+            final var upperPos = tilePos.up(queryPos);
+            final @NotNull Block<?> otherBlock = world.getBlockType(upperPos);
             if (!(otherBlock.getLogic() instanceof BlockLogicDoor)) {
                 world.setBlockTypeNotify(tilePos, Blocks.AIR);
                 hasCommittedSuicide = true;
@@ -233,11 +246,11 @@ public class BlockLogicDoor
                 world.setBlockTypeNotify(tilePos, Blocks.AIR);
                 hasCommittedSuicide = true;
                 if (otherBlock.getLogic() instanceof BlockLogicDoor) {
-                    world.setBlockTypeNotify(tilePos.up(queryPos), Blocks.AIR);
+                    world.setBlockTypeNotify(upperPos, Blocks.AIR);
                 }
             }
             if (!hasCommittedSuicide && block.isSignalSource()) {
-                final boolean hasSignal = world.hasNeighborSignal(tilePos) || world.hasNeighborSignal(tilePos.up(queryPos));
+                final boolean hasSignal = world.hasNeighborSignal(tilePos) || world.hasNeighborSignal(upperPos);
                 this.onPoweredBlockChange(world, tilePos, hasSignal);
             }
         }
@@ -286,128 +299,89 @@ public class BlockLogicDoor
 
     @Override
     public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePosc tilePos) {
-        if (tilePos.y() >= world.getHeightBlocks() - 1) {
-            return false;
-        } else {
-            return this.isSupported(world, tilePos, world.getBlockData(tilePos)) && super.canPlaceAt(world, tilePos.up(new TilePos()));
-        }
+        return this.canPlaceAt(world, tilePos, world.getBlockData(tilePos));
     }
 
     public boolean canPlaceAt(final @NotNull World world, final @NotNull TilePosc tilePos, final int data) {
-        if (tilePos.y() >= world.getHeightBlocks() - 1) {
-            return false;
-        } else {
-            return this.isSupported(world, tilePos, data) && super.canPlaceAt(world, tilePos.up(new TilePos()));
-        }
+        if (this.isTop) return false;
+        final var topPos = tilePos.up(new TilePos());
+        if (!super.canPlaceAt(world, tilePos) || !super.canPlaceAt(world, topPos)) return false;
+        return this.isSupported(world, tilePos, data);
     }
 
+    // public boolean areBothSupported(final @NotNull World world, final @NotNull TilePosc bottomPos, final @NotNull TilePosc topPos, final int data) {
+    //     return
+    //         this.isSupported(world, bottomPos, data, true, true) &&
+    //         this.isSupported(world, topPos, data, false, true);
+    // }
+
     public boolean isSupported(final @NotNull World world, final @NotNull TilePosc tilePos, final int data) {
+        return this.isSupported(world, tilePos, data, true, true);
+    }
+
+    public boolean isSupported(
+        final @NotNull World world, final @NotNull TilePosc tilePos, final int data,
+        boolean checkBottom, boolean checkHinge
+    ) {
         if (this.isTop) return true;
-        TilePos queryPos = new TilePos();
-        final @NotNull ISupport sBelow = world.getSupport(tilePos.down(queryPos), Side.TOP);
-        final boolean opened = (data & MASK_OPENED) != 0;
+        final var queryPos = new TilePos();
         final boolean hinge = (data & MASK_HINGE) != 0;
-        final @NotNull Side side;
-        final @NotNull ISupport hingeSupport;
-        if (opened) {
-            if (hinge) {
-                switch (this.getRotation(data)) {
-                    case 0: {
-                        side = Side.WEST;
-                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
-                        return sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
-                    }
-                    case 1: {
-                        side = Side.NORTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
-                        return sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
-                    }
-                    case 2: {
-                        side = Side.EAST;
-                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
-                        return sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
-                    }
-                    case 3: {
-                        side = Side.SOUTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
-                        return sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
-                    }
-
-                }
-            } else {
-                switch (this.getRotation(data)) {
-                    case 0: {
-                        side = Side.NORTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
-                        return sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
-                    }
-                    case 1: {
-                        side = Side.EAST;
-                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
-                        return sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
-                    }
-                    case 2: {
-                        side = Side.SOUTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
-                        return sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
-                    }
-                    case 3: {
-                        side = Side.WEST;
-                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
-                        return sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
-                    }
-                }
+        final @NotNull ISupport bottomSupport = world.getSupport(tilePos.down(queryPos), Side.TOP);
+        final int rotation = this.getRotation(data);
+
+        if (checkHinge) {
+            final @NotNull Side side; {
+                final int offset = switch (data & (MASK_OPENED | MASK_HINGE)) {
+                    default -> 0;
+                    case MASK_OPENED | MASK_HINGE -> 0;
+                    case MASK_OPENED, MASK_HINGE -> 1;
+                    case 0 -> 2;
+                };
+                final int sideRotation = (rotation + offset) & MASK_ROTATION;
+                side = switch (sideRotation) {
+                    default -> Side.NONE;
+                    case 0 -> Side.WEST;
+                    case 1 -> Side.NORTH;
+                    case 2 -> Side.EAST;
+                    case 3 -> Side.SOUTH;
+                };
             }
-        } else {
-            if (hinge) {
-                switch (this.getRotation(data)) {
-                    case 0: {
-                        side = Side.NORTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
-                        return sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
-                    }
-                    case 1: {
-                        side = Side.EAST;
-                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
-                        return sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
-                    }
-                    case 2: {
-                        side = Side.SOUTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
-                        return sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
-                    }
-                    case 3: {
-                        side = Side.WEST;
-                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
-                        return sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.right(), side);
-                    }
+            assert side != Side.NONE;
+    
+            final @NotNull ISupport hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
+            final @NotNull ISupport hingeSupported = (hinge)
+                ? PartialSupport.INSTANCE.left()
+                : PartialSupport.INSTANCE.right();
+    
+            if (hingeSupport.canSupport(hingeSupported, side)) return true;
+        }
 
-                }
-            } else {
-                switch (this.getRotation(data)) {
-                    case 0: {
-                        side = Side.EAST;
-                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
-                        return sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
-                    }
-                    case 1: {
-                        side = Side.SOUTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
-                        return sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.up(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
-                    }
-                    case 2: {
-                        side = Side.WEST;
-                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
-                        return sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.right(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
-                    }
-                    case 3: {
-                        side = Side.NORTH;
-                        hingeSupport = world.getSupport(tilePos.add(side.direction(), queryPos), side.opposite());
-                        return sBelow.canSupport(PartialSupport.INSTANCE.left(), Side.BOTTOM) || sBelow.canSupport(PartialSupport.INSTANCE.down(), Side.BOTTOM) || hingeSupport.canSupport(PartialSupport.INSTANCE.left(), side);
-                    }
-                }
-            }
+        if (checkBottom) {
+            final @NotNull ISupport bottomSupportedA = switch(rotation) {
+                default -> null;
+                case 0 -> PartialSupport.INSTANCE.up();
+                case 1 -> PartialSupport.INSTANCE.right();
+                case 2 -> PartialSupport.INSTANCE.down();
+                case 3 -> PartialSupport.INSTANCE.left();
+            };
+            assert bottomSupportedA != null;
+    
+            final int bottomBRotation = (hinge)
+                ? rotation
+                : (rotation + 2) & MASK_ROTATION;
+            final @NotNull ISupport bottomSupportedB = switch (bottomBRotation) {
+                default -> null;
+                case 0 -> PartialSupport.INSTANCE.right();
+                case 1 -> PartialSupport.INSTANCE.down();
+                case 2 -> PartialSupport.INSTANCE.left();
+                case 3 -> PartialSupport.INSTANCE.up();
+            };
+            assert bottomSupportedB != null;
+
+            if (bottomSupport.canSupport(bottomSupportedA, Side.BOTTOM) ||
+                bottomSupport.canSupport(bottomSupportedB, Side.BOTTOM)) return true;
         }
+
         return false;
     }
 
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
index 8b3c7b905..237696e82 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFarmland.java
@@ -211,16 +211,6 @@ public class BlockLogicFarmland
         return true;
     }
 
-    @Override
-    public boolean isEquivalent(@NotNull World world, @NotNull TilePosc thisPos, @NotNull TilePosc thatPos) {
-        final @Nullable Block<?> bBlock = world.getBlockType(thatPos);
-
-        final int thisMeta = world.getBlockData(thisPos);
-        final int otherMeta = world.getBlockData(thatPos);
-
-        return this.block == bBlock && isWet(thisMeta) == isWet(otherMeta);
-    }
-
     @Override
     public void updateTick(final @NotNull World world, final @NotNull TilePosc tilePos, final @NotNull Random rand, final boolean isRandomTick) {
         if (rand.nextInt(2) != 0) {
@@ -254,4 +244,10 @@ public class BlockLogicFarmland
 
         return false;
     }
+
+    @Override
+    protected int getMatcherEquivalenceData(int data) {
+        if ((data & MASK_WET) != 0) data |= MASK_WET;
+        return data;
+    }
 }
diff --git a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
index 315461b50..4525dde8e 100644
--- a/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
+++ b/game/core/src/main/java/net/minecraft/core/block/BlockLogicFence.java
@@ -18,6 +18,7 @@ import org.joml.primitives.AABBdc;
 
 import java.util.List;
 
+// TODO: metadata dependent connectors
 public class BlockLogicFence
     extends BlockLogic
     implements IPaintable {
